///////////////////////////////////////////////////////////////////////////////
#pragma hdrstop
#include <LibBiophysics.h>
//=============================================================================

void Hex_N2L(int _nx,int _ny,double _r,double *x,double *y)
{
  *y=_r*_ny*(M_SQRT3_2);
  if (_ny&0x01)
    *x=_r*_nx+0.5*_r;  // 1,3,5,...
  else
    *x=_nx*_r; // 0,2,4,...
}

//-----------------------------------------------------------------------------
double Hex_sqr2sz(double _S)
{
  return sqrt(_S/(3*M_SQRT3_2));
}

//-----------------------------------------------------------------------------
double Hex_sz2sqr(double _a)
{
  return _a*_a*3*M_SQRT3_2;
}
 //-----------------------------------------------------------------------------
double Tri_sqr2sz(double _S)
{
  return sqrt(_S/(M_SQRT3_2));
}

//-----------------------------------------------------------------------------
double Tri_sz2sqr(double _r)
{
  return _r*_r*M_SQRT3_2;
}

//-----------------------------------------------------------------------------
// Hear pos=0 <=> h=0, angle=0
double ProtHelix_pos2angle(double _pos)
{
  return _pos*U_PER_POS;
}

//-----------------------------------------------------------------------------
double ProtHelix_pos2height(double _pos)
{
  return _pos*H_PER_POS;
}

//-----------------------------------------------------------------------------
void FindBest_sqr2num(int *n1,int *n2,double _area,double _single, char _dir)
{
  double s0=_area/_single;
  char d=((_dir>=0)?1:-1);
  char FLAG=0;
  double e1,e2,e,E=s0;

  *n2=round(sqrt(s0));
  e1=fabs(s0-(*n2-d)*round(s0/(*n2-d)));
  e=fabs(s0-*n2*round(s0/(*n2)));
  while (FLAG!=2){
    // if d=-1 and n2=1 there is an error
    if ((*n2+d)!=0)
      e2=fabs(s0-(*n2+d)*round(s0/(*n2+d)) );
    else e2=fabs(s0);

    if ((e1>e)&(e2>e)){
      FLAG++;
      if (e<E){
        *n1=*n2;
        E=e;
      }
    }
    *n2+=d;
    e1=e;
    e=e2;
  }
  *n2=round(s0/(*n1));
}

//-----------------------------------------------------------------------------

int Double2Int(double _n)
{
  double r=randu();
  if (r>(_n-floor(_n))) return floor(_n);
  else return floor(_n)+1;
}


//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------



